// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from autoware_sensing_msgs:msg/GnssInsOrientation.idl
// generated code does not contain a copyright notice

#include "autoware_sensing_msgs/msg/detail/gnss_ins_orientation__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_autoware_sensing_msgs
const rosidl_type_hash_t *
autoware_sensing_msgs__msg__GnssInsOrientation__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x3e, 0xb6, 0x1e, 0x3c, 0x89, 0xc9, 0x43, 0xa0,
      0xdd, 0x9d, 0x40, 0xec, 0xfa, 0x83, 0xcd, 0x5a,
      0xa6, 0xa2, 0xe9, 0x01, 0x70, 0xc1, 0xe6, 0xb7,
      0xb0, 0xa7, 0x5b, 0xea, 0xc0, 0x8d, 0x25, 0x19,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "geometry_msgs/msg/detail/quaternion__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t geometry_msgs__msg__Quaternion__EXPECTED_HASH = {1, {
    0x8a, 0x76, 0x5f, 0x66, 0x77, 0x8c, 0x8f, 0xf7,
    0xc8, 0xab, 0x94, 0xaf, 0xcc, 0x59, 0x0a, 0x2e,
    0xd5, 0x32, 0x5a, 0x1d, 0x9a, 0x07, 0x6f, 0xff,
    0xf3, 0x8f, 0xbc, 0xe3, 0x6f, 0x45, 0x86, 0x84,
  }};
#endif

static char autoware_sensing_msgs__msg__GnssInsOrientation__TYPE_NAME[] = "autoware_sensing_msgs/msg/GnssInsOrientation";
static char geometry_msgs__msg__Quaternion__TYPE_NAME[] = "geometry_msgs/msg/Quaternion";

// Define type names, field names, and default values
static char autoware_sensing_msgs__msg__GnssInsOrientation__FIELD_NAME__orientation[] = "orientation";
static char autoware_sensing_msgs__msg__GnssInsOrientation__FIELD_NAME__rmse_rotation_x[] = "rmse_rotation_x";
static char autoware_sensing_msgs__msg__GnssInsOrientation__FIELD_NAME__rmse_rotation_y[] = "rmse_rotation_y";
static char autoware_sensing_msgs__msg__GnssInsOrientation__FIELD_NAME__rmse_rotation_z[] = "rmse_rotation_z";

static rosidl_runtime_c__type_description__Field autoware_sensing_msgs__msg__GnssInsOrientation__FIELDS[] = {
  {
    {autoware_sensing_msgs__msg__GnssInsOrientation__FIELD_NAME__orientation, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {geometry_msgs__msg__Quaternion__TYPE_NAME, 28, 28},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_sensing_msgs__msg__GnssInsOrientation__FIELD_NAME__rmse_rotation_x, 15, 15},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_sensing_msgs__msg__GnssInsOrientation__FIELD_NAME__rmse_rotation_y, 15, 15},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_sensing_msgs__msg__GnssInsOrientation__FIELD_NAME__rmse_rotation_z, 15, 15},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription autoware_sensing_msgs__msg__GnssInsOrientation__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {geometry_msgs__msg__Quaternion__TYPE_NAME, 28, 28},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
autoware_sensing_msgs__msg__GnssInsOrientation__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {autoware_sensing_msgs__msg__GnssInsOrientation__TYPE_NAME, 44, 44},
      {autoware_sensing_msgs__msg__GnssInsOrientation__FIELDS, 4, 4},
    },
    {autoware_sensing_msgs__msg__GnssInsOrientation__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&geometry_msgs__msg__Quaternion__EXPECTED_HASH, geometry_msgs__msg__Quaternion__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = geometry_msgs__msg__Quaternion__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# GNSS(Global Navigation Satellite System) INS(Inertial Navigation System) orientation message\n"
  "#\n"
  "# Represents a 3D orientation in a global coordinate system.\n"
  "#\n"
  "# ROS uses ENU axes convention (East, North, Up) corresponds to (x, y, z).\n"
  "\n"
  "# Quaternion representation of the orientation.\n"
  "geometry_msgs/Quaternion orientation\n"
  "\n"
  "# Root mean square error of the rotation [rad]\n"
  "# (x, y, z) axes corresponding to (roll, pitch, yaw)\n"
  "float32 rmse_rotation_x\n"
  "float32 rmse_rotation_y\n"
  "float32 rmse_rotation_z";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
autoware_sensing_msgs__msg__GnssInsOrientation__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {autoware_sensing_msgs__msg__GnssInsOrientation__TYPE_NAME, 44, 44},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 494, 494},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
autoware_sensing_msgs__msg__GnssInsOrientation__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *autoware_sensing_msgs__msg__GnssInsOrientation__get_individual_type_description_source(NULL),
    sources[1] = *geometry_msgs__msg__Quaternion__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
